' FileName: FBAudit.Bas
' Date: 1/7/2017
' Author: Ben Ritchey
' Description: Audit current Sub-dir against Descript.ion file

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

LOCAL A, C, E, FNAME, ONAME AS STRING
LOCAL B, D, TFLAG AS LONG
LOCAL Z AS STRING
LOCAL AA, AB AS LONG
LOCAL PFT, MaxFT, FTT, FTI, L AS LONG
LOCAL AC AS STRING
LOCAL PgmVer as String
Local FTab() as String

' Code Starts Here * * * * * * * *
  ON ERROR GOTO INTERROR

' Do NOT change format of next line except x-x !!!
  PgmVer=" FBAudit v1.0.D "
200  COLOR 7
  PRINT " ";CHR$(232);PgmVer;"Audit in progress ... "
  PRINT " ";CHR$(232);" Loading real File table ... ";
  FTT=2000: Dim FTab(FTT): FTI=1
  Shell "cmd /c dir /b >FBAudit.Lst & echo.>>FBAudit.Lst"
  Open "FBAudit.Lst" for Input as #1

NxtFT:
  If not eof(1) then Line input#1,A else goto EndFT
  FTab(FTI)=trim$(A): Incr FTI
  If FTI<FTT then Goto NxtFT
  Z=chr$(7)+"*** Fatal Error: FTab overflow (FTT="+trim$(str$(FTT))+")"
  Gosub Prompt
  Goto Finished

EndFT:
  MaxFT=FTI: Print MaxFT;" records": PFT=MaxFT

  close 1: kill "FBAudit.Lst"
1000  COLOR 14
  PRINT " ";CHR$(232);" Syncing real Files to Descript.ion ... "

OPEN "DESCRIPT.ION" FOR INPUT AS #1
OPEN "\DESAUDIT.RPT" FOR output AS #2
Z=" -=:{  FileBase Directory Audit Report  }:=- ": gosub MsgCenter2
Print #2
Z=" On "+date$+" at "+time$: gosub MsgCenter2
Print #2
Z=" Path: "+curdir$+" ": gosub MsgCenter2
Print #2,string$(79,"_")
Print #2

NextION:

If not eof(1) then LINE INPUT#1,A else GOTO SrchFTEnd

A=trim$(A)
IF A="" THEN GOTO NEXTION ' Skip BLANK LINEs
B=ASC(MID$(A,1,1))
IF B<33 OR B>126 THEN GOTO NEXTION  ' Skip INVALID ASCII OR SPace in Col 1

'  ' Debug ******** ???
'B=INSTR(A,".")
'IF (B=0 and len(A)>8) or B>9 THEN goto NextION  ' Skip LFNs?

B=INSTR(A," ")
IF B=0 THEN FNAME$=trim$(ucase$(A)) ELSE FNAME$=trim$(ucase$(MID$(A,1,B-1)))

FTI=1
While FTI<MaxFT
  If FTab(FTI)="" then goto SrchFT
  If FName=trim$(ucase$(FTab(FTI))) then
    FTab(FTI)="": PFT=PFT-1
    goto NextION
  end if
SrchFT:
  Incr FTI
Wend

Print #2," File/Dir ";FName;" [";A;"] not found on disk "
Goto NextION

SrchFTEnd:
'Print " ";chr$(232);" ";PFT;" records failed pass 1 "
Print #2

FTI=1
While FTI<MaxFT
  If FTab(FTI)<>"" then print #2," [";FTab(FTI);"] not in Descript.ion "
  Incr FTI
Wend
Print #2
Print #2,string$(79,"_")
Z=" -=:{  End of Audit Report  }:=- ": gosub MsgCenter2

2000
FINALIZE:
2010
CLOSE
Z=" "+chr$(232)+" Audit complete ... press {Enter}": gosub prompt
2015
 IF ISFILE("\DesAudit.Rpt") then
   shell "cmd /c dvwview \DesAudit.rpt"
'   kill "Descript.new"
 end if
2040
' * * * * * * * *  C O D E  G O E S  H E R E  * * * * * * * *

REM  ERROR(123)
  GOTO FINISHED

PROMPT:
  COLOR 7: PRINT Z: COLOR 15: INPUT A$
  COLOR 3
 RETURN
MESSAGE:
  PRINT Z$
 RETURN
MSGCenter2:
  PRINT #2,space$((80-len(Z))/2);Z$
 RETURN

INTERROR:
  AB=ERL: AA=ERRCLEAR: AC=ERROR$(AA)

10000 PRINT

  BEEP
  COLOR 14
  PRINT "  Internal Error: ";
  COLOR 3: PRINT "Line";
  COLOR 15: PRINT AB;: COLOR 3: PRINT "  Code";
  COLOR 15: PRINT AA;: COLOR 3: PRINT " = ";
  COLOR 15: PRINT AC
  COLOR 3: PRINT "  Press any key ...";

  A="": WHILE A="": A=INKEY$: WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED

' *** Debug
  BEEP
  PRINT "Ok": A="": WHILE A="": A=INKEY$: WEND
' *** Debug

FINISHED:
55000 COLOR 7
  ON ERROR GOTO EXITOR

55500  PRINT
'  CLOSE
'  SHELL "CLS"

EXITOR:

END FUNCTION

' End of PBD2PBD.Bas

